"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BUILTINS = void 0;
const types_1 = require("@babel/types");
exports.BUILTINS = [
    'electron',
    'buffer',
    'child_process',
    'crypto',
    'dgram',
    'dns',
    'fs',
    'http',
    'https',
    'net',
    'os',
    'readline',
    'stream',
    'string_decoder',
    'tls',
    'tty',
    'zlib',
    'constants',
    'events',
    'url',
    'assert',
    'util',
    'path',
    'punycode',
    'querystring',
    'cluster',
    'console',
    'module',
    'process',
    'vm',
    'domain',
    'v8',
    'repl',
    'timers',
    'node-fetch',
    'jest',
    '@testing-library/react',
    '@testing-library/dom',
];
const IGNORED_MODULES = [
    'bufferutil',
    'utf-8-validate',
    'spawn-sync',
    './src/logcat',
    './src/monkey',
    './src/adb',
];
module.exports = () => ({
    name: 'change-require-to-electronRequire-in-electron-app',
    visitor: {
        CallExpression(path) {
            const node = path.node;
            if (node.type === 'CallExpression' &&
                node.callee.type === 'Identifier' &&
                node.callee.name === 'require' &&
                node.arguments.length === 1 &&
                node.arguments[0].type === 'StringLiteral') {
                const source = node.arguments[0].value;
                if (exports.BUILTINS.includes(source) ||
                    exports.BUILTINS.some((moduleName) => source.startsWith(`${moduleName}/`))) {
                    node.callee.name = 'electronRequire';
                }
                if (IGNORED_MODULES.includes(source)) {
                    path.replaceWith((0, types_1.identifier)('triggerReferenceError'));
                }
            }
        },
    },
});
module.exports.BUILTINS = exports.BUILTINS;
//# sourceMappingURL=electron-requires.js.map